/*
 * 20170728-05-6050.c
 */

#include <stdio.h>
#include "s_print.h"

/*
 *
 */

#define	EOS		'\0'	/* define を使って '\0' に EOS という名前を付ける */

/*
 *
 */

/*
 * void echo_n_times_message ( char *message )
 *
 *	機能
 *		引数が空文字列の時には、「空文字列です」を一回だけ出力する
 *		引数で指定された文字列の先頭が数字の場合は、その後をその数字の表わす回数だけ繰り返す
 *		そうでなければ、一度だけ出力
 *	引数
 *		char * message : 出力する文字列
 *	返値
 *		void : なし
 */

void	echo_n_times_message ( char *message ) {

	if ( *message == EOS ) {		/* 空文字列だった */
		s_print_string ( "空文字列です" );	/* 「空文字列です」を出力 */
	} else if ( *message == 'X' ) {	/* 先頭が 'X' で始まる */
		s_print_string ( message + 1 );		/* 'X' を取り除いた残りを 2 度出力 */
		s_print_string ( message + 1 );

	/*
	**	 この部分を完成させなさい
	*/

	} else {						/* そうでなかった */
		s_print_string ( message );			/* 文字列をそのまま一度だけ出力 */
	}
}

/*
 *
 */

void check_echo_n_times_message ( char *message ) {

	s_print_string ( "文字列 \"" );
	s_print_string ( message );
	s_print_string ( "\" を出力させると「" );

	echo_n_times_message ( message );

	s_print_string ( "」になります。\n" );

}

/*
 *
 */

int main ( int argc, char *argv[] ) {

	s_print_string ( "\" abc\" の場合 : " );
	check_echo_n_times_message ( " abc" );

	s_print_string ( "\" abc\" 先頭に 'X' を付けた場合 : " );
	check_echo_n_times_message ( "X abc" );

	s_print_string ( "\" abc\" 先頭に 'j' を付けた場合 : " );
	check_echo_n_times_message ( "j abc" );

	s_print_string ( "\"\" (空文字列) の場合 : " );
	check_echo_n_times_message ( "" );

	return 0;
}

/*
 *
 */

